<script setup lang="ts">
    import { InterventionFilters } from '@/interventionServiceOffer/entities/intervention/filters/InterventionFilters'
    import { computed } from 'vue'
    import { FilterChoice } from '@/shared/filters/entities/FilterChoiceInterface'
    import { InterventionHistorisedStatusDto } from '@/interventionServiceOffer/entities/intervention/status/InterventionHistorisedStatusDto'
    import { isUndefined, requiredInject } from '@/shared/helpers/types'
    import { myselfGmaoActeurInjectionKey } from '@/interventionServiceOffer/constants'
    import { useRechercheGmaoActeur } from '@/interventionServiceOffer/composables/gmaoActeur/useRechercheGmaoActeur'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { allElementsAreIdentical } from '@/shared/helpers/identifiable'
    import { isDefined } from '@/shared/helpers/types'
    import { InterventionPriority } from '@/interventionServiceOffer/entities/intervention/InterventionDto'
    import SDateRangeFilter from '@/shared/filters/components/SDateRangeFilter.vue'

    const msal = useMsal()
    const interventionFilters = defineModel<InterventionFilters>({
        required: true,
    })

    const avaibleStatus: FilterChoice[] &
        {
            label: string
            value: InterventionHistorisedStatusDto['code']
        }[] = [
        { label: 'A faire', value: 'awaiting_realisation' },
        { label: 'Réalisé', value: 'closed' },
    ]

    const Priorités: FilterChoice[] &
        {
            label: string
            value: InterventionPriority
        }[] = (
        Object.keys(InterventionPriority) as Array<
            keyof typeof InterventionPriority
        >
    ).map((interventionPriorityKey) => {
        return {
            label: interventionPriorityKey,
            value: InterventionPriority[interventionPriorityKey],
        }
    })

    const {
        resultatsRecherche: choixIntervenants,
        nomCompletRecherché: nomCompletIntervenantRecherché,
        isLoading: choixIntervenantsIsLoading,
    } = useRechercheGmaoActeur(msal)

    const myself = requiredInject(myselfGmaoActeurInjectionKey)

    function filtrerSurLesInterventionsAttribuéesALAgentConnecté() {
        if (isUndefined(myself.value)) {
            return
        }
        interventionFilters.value.filters['intervenantsAffectes.id'] = [
            myself.value,
        ]
    }
    const lesInterventionsSontFiltréeSurLAgentConnecté = computed(() => {
        return allElementsAreIdentical(
            interventionFilters.value.filters['intervenantsAffectes.id'],
            [myself.value]
        )
    })
</script>

<template>
    <span class="d-flex align-center py-4 pl-2">
        <v-icon size="x-large">mdi-filter-outline</v-icon>
        <h2 class="text-h8 ml-2">Filtrer par</h2>
    </span>

    <v-list lines="one" density="compact">
        <v-list-subheader>Etat actuel</v-list-subheader>
        <v-list-item density="compact">
            <v-checkbox
                v-for="status in avaibleStatus"
                :key="status.value"
                v-model="interventionFilters.filters.statuses"
                :label="status.label"
                data-cy="status-filter"
                hide-details
                color="primary"
                density="compact"
                :value="status.value"
            ></v-checkbox>
        </v-list-item>
        <v-list-subheader>Date de début</v-list-subheader>
        <v-list-item>
            <s-date-range-filter
                v-model:date-debut-intervalle="
                    interventionFilters.filters['dateDeDebut[after]']
                "
                v-model:date-fin-intervalle="
                    interventionFilters.filters['dateDeDebut[before]']
                "
                data-cy="input-intervalle-date-debut"
            />
        </v-list-item>
        <v-list-subheader>Date de fin</v-list-subheader>
        <v-list-item>
            <s-date-range-filter
                v-model:date-debut-intervalle="
                    interventionFilters.filters['dateDeFin[after]']
                "
                v-model:date-fin-intervalle="
                    interventionFilters.filters['dateDeFin[before]']
                "
                data-cy="input-intervalle-date-fin"
            />
        </v-list-item>

        <v-list-subheader>Priorités</v-list-subheader>
        <v-list-item density="compact">
            <v-checkbox
                v-for="priority in Priorités"
                :key="priority.value"
                v-model="interventionFilters.filters.priority"
                :label="priority.label"
                :data-cy="`priority-filter-${priority.value}`"
                hide-details
                color="primary"
                density="compact"
                :value="priority.value"
            ></v-checkbox>
        </v-list-item>

        <v-list-subheader> Intervenants </v-list-subheader>
        <v-list-item>
            <v-autocomplete
                v-model="interventionFilters.filters['intervenantsAffectes.id']"
                v-model:search="nomCompletIntervenantRecherché"
                label="Rechercher un intervenant"
                placeholder="ex: Jean Doux"
                variant="outlined"
                class="mt-2"
                data-cy="select-intervenant"
                item-title="nomComplet"
                return-object
                prepend-inner-icon="mdi-account-search-outline"
                multiple
                chips
                closable-chips
                hide-no-data
                hide-details
                :items="choixIntervenants"
                :loading="choixIntervenantsIsLoading"
            ></v-autocomplete>
            <a
                v-if="
                    isDefined(myself) &&
                    !lesInterventionsSontFiltréeSurLAgentConnecté
                "
                class="text-body-2 cursor-pointer"
                data-cy="assigne-utilisateur-connecte"
                @click.prevent="
                    filtrerSurLesInterventionsAttribuéesALAgentConnecté()
                "
                >attribuées à moi uniquement</a
            >
        </v-list-item>
    </v-list>
</template>
